# Makatto

Makatto is a simple webdev stack which which compiles LESS/EJS templates and build a production version of your website.

It also can run as a HTTP server, which watches your files for changes, automatically compiles them and refreshes your browser.

## Install

```
npm install makatto -g
```

## Usage

### Building

Runs the build process once.

```
makatto
```

### Server

Runs the build process once initialy and then everytime some file changes.

```
makatto --server
```

Now point your browser to http://localhost:port (for `port` see _Configuration_) and start to edit your sources.

## Configuration

Key                          | Description                                             | Default
---------------------------- | ------------------------------------------------------- | -------
**src**                      | Path to tde SRC folder (where you develop your web)     | `./src`
**dist**                     | Path to tde DIST folder (where your web will be built)  | `./dist`
**cssmin**                   | Compress the CSS files (using LESS builtin compressing) | `false`
**jsmin**                    | Compress the JS files (using uglify-js compressing)     | `false`
**imgmin**                   | Optimize images (using pngout)                          | `false`
**port** (server only)       | Port on which tde HTTP and WebSocket server will run    | `9000`
**livereload** (server only) | Starts the server in live reload mode (see below)       | `false`

### Override defaults with CLI arguments

```
makatto --server --port <port> --src <path_to_src> --dist <path_to_dist> --livereload --jsmin --cssmin --imgmin
```

### Override defaults with `config.js` file

```
makatto --config path_to_config.js
```
    
An example of such config.js could be:

```javascript
{
  "port"          : 8888,
  "src"           : "c:/web/source",
  "dist"          : "c:/web/build"
  "livereload"    : true,
  "jsmin"         : true,
  "cssmin"        : false,
  "imgmin"        : true
}
```

## Live reload mode (server)

If the server is started in live reload mode, each HTML page gets a live reload javascript injected, which automatically reloads CSS/Images/Page after some files are changed:

  * If an image or CSS is changed and is present on page, it will be **hotswapped** without page reload
  * If a HTML page or a Javascript file is changed, the whole page is reloaded
