var fs       = require("fs");
var path     = require("path");
var keypress = require("keypress");

exports.init = function(callback) {
	keypress(process.stdin);
	process.stdin.on("keypress", function (ch, key) {
		if (key && key.ctrl && key.name === "c") {
			callback && callback();
			quit();
		}
	});
	process.stdin.setRawMode(true);
	process.stdin.resume();
};

exports.getConfig = function(cfgFile) {
	var _config = {};
	
	if (fs.existsSync(cfgFile)) {
		_config = JSON.parse(fs.readFileSync(cfgFile, "utf-8"));
	}
	
	var config = {};
		config.port          = _config.port          || 9000;
		config.srcDir        = _config.src           || process.cwd() + "/src";
		config.distDir       = _config.dist          || process.cwd() + "/dist";
		config.httpRoot      = config.distDir;
		config.livereload    = _config.livereload    || false;
		config.cssmin        = _config.cssmin        || false;
		config.jsmin         = _config.jsmin         || false;
		config.imgmin        = _config.imgmin        || false;
		config.rootDir       = path.normalize(path.dirname(module.filename) + "/..");
		config.libDir        = path.normalize(config.rootDir + "/lib");
		config.binDir        = path.normalize(config.rootDir + "/bin");
		
	return config;
};

exports.quit = quit = function(msg) {
	msg && console.log(msg);
	process.exit();
};
